import sys
import dumpParser

def set(a,index,value):
    while ( len(a)<=index):
        a.append(0)
    a[index]=value

def get(a,index):
    while ( len(a)<=index):
        a.append(0)
    return a[index];

def getArray(a,index):
    while ( len(a)<=index):
        a.append([])
    return a[index];

class EdgeDensityGenerator:
    out = None
    outVector = []
    
    def __init__(self,output):
        self.out = output

    def nodeOut(self,id):
        return

    def initialCode(self):
        return

    def edgeOut(self,idSrc,idTrg):
        for i in range(len(idSrc)):
            protoVector = getArray(self.outVector,i)
            s1id = idSrc[i]
            s2id = idTrg[i]
            if s1id<s2id:
                set(protoVector,s1id,get(protoVector,s1id)+1)
                set(protoVector,s2id,get(protoVector,s2id)-1)
                continue
            if s1id>s2id:
                set(protoVector,s1id,get(protoVector,s1id)-1)
                set(protoVector,s2id,get(protoVector,s2id)+1)
        return
    
    def terminalCode(self):
        fileN = 0
        for protoVector in self.outVector:
            sum = 0;
            outF = file(self.out+"_edge_"+`fileN`,"w")
            for i in range(len(protoVector)):
                sum = sum + protoVector[i]
                outF.write(`i`+"\t"+`sum`+"\n")
            outF.close()
            fileN = fileN+1
        return


class NodeDensityGenerator:
    out = None
    outVector = []
    
    def __init__(self,output):
        self.out = output

    def nodeOut(self,id):
        for i in range(len(id)):
            protoVector = getArray(self.outVector,i)
            protoId = id[i]
            set(protoVector,protoId,get(protoVector,protoId)+1)
        return

    def initialCode(self):
        return

    def edgeOut(self,idSrc,idTrg):
        return
    
    def terminalCode(self):
        fileN = 0
        for protoVector in self.outVector:
            outF = file(self.out+"_node_"+`fileN`,"w")
            for i in range(len(protoVector)):
                outF.write(`i`+"\t"+`protoVector[i]`+"\n")
            outF.close()
            fileN = fileN+1
        return


generators = []
generators.append(EdgeDensityGenerator(sys.argv[2]))
generators.append(NodeDensityGenerator(sys.argv[2]))

dp = dumpParser.DumpParser(generators)
input = file(sys.argv[1])

dp.parse(input)


